/////////////////////////////////////////////////////////////////
//Henon Fluchdiagramm  Kapitel Fraktale
//////////////////////////////////////////////////////////////
float alpha = 1.4;
float beta = 0.3;
float xU =-2.5; 
float xO =1.5;
float yU = -0.5; 
float yO = 0.5;
float xAlt, yAlt, xNeu, yNeu, xStart, yStart, xE, yE;
boolean rechne, achsenZeichnen, startPunktZeichnen, fluchtBereich;
PFont font;
int w = 1000; 
int h = 1000; 
int n, i, j, xK, yK, x0, y0, xEPixel, yEPixel;
color[] farben = {color(255, 0, 0), color(0, 255, 0), color(0, 0, 255), 
                  color(255, 255, 0), color(255, 0, 255), color(0, 255, 255)};                   
double d;
String s;


////////////////////////////////////////////////////////////////

void setup() { 
  background(255);
  surface.setSize(w,h);
  fill(0); 
  textSize(12);
  // font = loadFont("ArialMT-12.vlw");
  n= 50; 
  i=0; 
  j=0;
  rechne = false;
  xAlt = 0; 
  yAlt = 0;
  xStart = 0; 
  yStart = 0; 
  x0 = round( map(0, xU, xO, 0, w));  //Pixelspalte bei der x=0;
  y0 = round (map(0, yU, yO, h, 0));  //Pixelzeile bei der y=0;
  achsenZeichnen = false;
  startPunktZeichnen = false;
  fluchtBereich = false;
}

void draw() {
  //Berechnung der n-fachen Henon-Abbildung für einen Punkt 
  if (rechne) {
    xNeu = yAlt+1-alpha*xAlt*xAlt;
    yNeu = beta*xAlt; 
    if (Math.abs(xNeu) <= 100 && Math.abs(yNeu) <= 100 && i <=n) {
      xK = round( map(xNeu, xU, xO, 0, w));                              
      yK = round (map(yNeu, yU, yO, h, 0));                      
      fill(farben[j]); 
      rect(xK-1, yK-1, 3, 3);    
      xAlt = xNeu;
      yAlt = yNeu;
      i++;
      if (i>=n) {
        rechne = false;
        j = (j+1) % 6;
        stroke(farben[j]);    
        i=0;
      } 
      if (Math.abs(xNeu) >= 10 || Math.abs(yNeu) >= 10) {
        stroke(0); 
        textSize(14); 
        text("Punkte divergieren", 20, 20);
        j = (j+1) % 6;
        stroke(farben[j]);    
        i=0;
      }
    }
  }
  //Koordinatenachsen mit Einheit zeichnen
  if (achsenZeichnen) { 
    stroke(0); 
    textSize(14); 
    fill(0); 
    line(x0, 0, x0, h);  //y-Achse   
    line(0, y0, w, y0);  //x-Achse
    einheitX("0,5", 0.5);
    einheitY("0,1", 0.1);
    achsenZeichnen = false;
  }
  //Größeren Startpunkt zeichnen 
  if (startPunktZeichnen) { 
    rect(xStart-3, yStart-3, 6, 6);  
    startPunktZeichnen = false;
  }
  //Fluchtbereich markieren
  if (fluchtBereich) {
    for (int l = 1; l<=w; l++) {
      for (int s =1; s<=h; s++) {
        xAlt = map(l, 0, w, xU, xO);
        yAlt = map(s, 0, h, yO, yU);
        for (int k =0; k <= 100; k++) {
          xNeu = yAlt+1-alpha*xAlt*xAlt;
          yNeu = beta*xAlt; 
          xAlt = xNeu; 
          yAlt = yNeu;
        }
        d = Math.sqrt(xAlt*xAlt + yAlt*yAlt);
        if (d<= 10) {
          stroke(255); 
          point(l, s);
        } else {
          stroke(150); 
          point(l, s);
        }
      }
    }     
    fluchtBereich = false;
  }
}

void keyPressed() {
  if (key == 'f') fluchtBereich = true; 
  if (key == 'k') achsenZeichnen = true; 
  if (key == 's') save("ergebnis.png");
} 

void mousePressed() {    
  stroke(farben[j]);
  xStart = mouseX; 
  yStart = mouseY;
  xAlt= map(xStart, 0, w, xU, xO); 
  yAlt= map(yStart, 0, h, yO, yU);
  startPunktZeichnen = true; 
  rechne = true;
}

void einheitX(String ps, float pxE) {
  s=ps;
  xE = pxE;
  xEPixel = round( map(xE, xU, xO, 0, w));   
  line(xEPixel, y0-10, xEPixel, y0+10); 
  text(s, xEPixel-15, y0+25);
}

void einheitY(String ps, float pyE) {
  s = ps;
  yE = pyE;
  yEPixel = round (map(yE, yU, yO, h, 0));   
  line(x0-10, yEPixel, x0+10, yEPixel);
  text(s, x0-40, yEPixel+5);
}